#!/usr/bin/env node
'use strict';

var _Create = require('./cli/Create');

var _Create2 = _interopRequireDefault(_Create);

var _Builder = require('./cli/Builder');

var _Builder2 = _interopRequireDefault(_Builder);

var _child_process = require('child_process');

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _package = require('../package');

var _package2 = _interopRequireDefault(_package);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_commander2.default.version(_package2.default.version).option('-p, --port <port>', 'Port on which to listen to (defaults to 8000)', parseInt).option('-i, --interactive', 'open in browser').option('-N, --pname <pname>', 'pm2 server name').option('-w, --webport <webport>', 'website port').option('-f, --folder <folder>', '--folder draft|sites').option('-d, --destination <destination>', '--folder draft|sites').parse(process.argv);

var userArgs = process.argv.slice(2);
var create = new _Create2.default();
var port = _commander2.default.port;
var interactive = _commander2.default.interactive;
var pm2Name = _commander2.default.pname;
var webport = _commander2.default.webport || 8081;

if (typeof userArgs[0] !== 'undefined' && userArgs[0] !== null) {

	switch (userArgs[0]) {
		case 'build':
			var dir = process.cwd();
			process.chdir(__dirname + '/../');
			var command = 'ROOT=' + dir + ' FOLDER=' + (_commander2.default.folder ? _commander2.default.folder : 'draft') + ' DEST=' + (_commander2.default.destination ? _commander2.default.destination : 'tmp') + ' npm run build:folder';
			(0, _child_process.exec)(command, function (err, out, code) {
				if (err instanceof Error) throw err;
				// process.stderr.write(err)
				// process.stdout.write(out)
				process.exit(code);
			});
			break;
		case 'create':
			if (userArgs[1]) create.init(userArgs[1]);else console.error("Error: no project path specified");
			break;
		case 'serve':
			var dir = process.cwd();
			var command = 'WEBPORT=' + webport + ' ROOT=' + dir + ' npm run start';
			if (interactive) command = 'OPENURL=1 ' + command;
			if (port) command = 'PORT=' + port + ' ' + command;
			process.chdir(__dirname + '/../');
			console.log('website stared : ' + dir + (port ? ' on port :' + port : ''));
			(0, _child_process.exec)(command, function (err, out, code) {
				if (err instanceof Error) throw err;
				// process.stderr.write(err)
				// process.stdout.write(out)
				process.exit(code);
			});
			break;
		case 'servepm2':
			var dir = process.cwd();
			var command = 'WEBPORT=' + webport + ' ROOT=' + dir + " pm2 start ./dist/server/index.js --node-args='--harmony'";
			if (interactive) command = 'OPENURL=1 ' + command;
			if (port) command = 'PORT=' + port + ' ' + command;
			if (pm2Name) command = command + (' --name="' + pm2Name + '"');
			process.chdir(__dirname + '/../');
			console.log('pm2 command : ' + command);
			(0, _child_process.exec)(command, function (err, out, code) {
				if (err instanceof Error) throw err;
				// process.stderr.write(err)
				// process.stdout.write(out)
				process.exit(code);
			});
			break;
		case 'servenodemon':
			var dir = process.cwd();
			var command = 'WEBPORT=' + webport + ' ROOT=' + dir + ' npm run startdev';
			if (interactive) command = 'OPENURL=1 ' + command;
			if (port) command = 'PORT=' + port + ' ' + command;
			process.chdir(__dirname + '/../');
			console.log('website stared : ' + dir + (port ? ' on port :' + port : ''));
			(0, _child_process.exec)(command, function (err, out, code) {
				if (err instanceof Error) throw err;
				// process.stderr.write(err)
				// process.stdout.write(out)
				process.exit(code);
			});
			break;
		case 'stop':
			(0, _child_process.exec)('pm2 delete all', function (err, out, code) {
				if (err instanceof Error) throw err;
				// process.stderr.write(err)
				// process.stdout.write(out)
				process.exit(code);
			});
			break;
		default:
			console.log("Help: use `create` or `serve` command");
			break;
	}
} else {
	console.log("Help: use `create` or `serve` command");
}