import {Hooks} from '../../'

export default function addWorkflow (flows, userFlow, currentFlow, text) {
  var res = Hooks.instance.trigger('beforeAddWorkflow', flows, userFlow, currentFlow, text)
  var displayFlow = 'draft'
  flows = ['draft'].concat(flows)
  flows = flows.concat('publish')

  var foundFlow = false
  var keepGoing = true
  var hasReject = false
  var i = 0

  if(currentFlow === 'draft'){
    res += `<button class='btn btn-info btn-save btn-hidden' data-action="draft">
            <span class="before">
              ${text.save}
            </span>
            <span class="loading">
              ${text.saving}
            </span>
            <span class="after">
              ${text.done}
            </span>
          </button>`
  }

  flows.forEach(function (flow) {
    if(!keepGoing) return;

    if(userFlow.workflow.indexOf(flow) > -1 && flow !== 'draft'){
      displayFlow = foundFlow ? flow : 'reject'

      if((displayFlow !== 'reject' && currentFlow !== flow) || (!hasReject && displayFlow === 'reject')){
        res += `<button class='btn btn-info btn-save' data-action="${displayFlow}">
                  <span class="before">
                    ${displayFlow}
                  </span>
                  <span class="loading">
                    ${text.saving}
                  </span>
                  <span class="after">
                    ${text.done}
                  </span>
                </button>`
      }
      if(foundFlow) keepGoing = false
      if(displayFlow === 'reject') hasReject = true
    }

    if(currentFlow === flow || userFlow.index == i++) foundFlow = true
  })

  if(/data-action/g.test(res) && res.match(/data-action/g).length === 1 && /data-action="reject"/g.test(res)){
    res = res.replace(/<span class="before">(\r|\t|\n|.)*?<\/span>/, '<span class="before">edit<\/span>')
  }

  res += Hooks.instance.trigger('afterAddWorkflow', flows, userFlow, currentFlow, text)

  return res
}
