import Handlebars from 'handlebars'
import HandlebarsIntl from 'handlebars-intl'

/* Handlebar utilities */
import attrAbe 		from './utils/attrAbe'
import className 	from './utils/className'
import cleanTab 	from './utils/cleanTab'
import ifCond 		from './utils/ifCond'
import ifIn 			from './utils/ifIn'
import math 			from './utils/math'
import moduloIf 	from './utils/moduloIf'
import notEmpty 	from './utils/notEmpty'
import printJson 	from './utils/printJson'
import testObj 		from './utils/testObj'
import translate 	from './utils/translate'

/* Handlebar abe */
import abeEngine 						from './abe/abeEngine'
import abeImport 						from './abe/abeImport'
import addWorkflow 					from './abe/addWorkflow'
import compileAbe 					from './abe/compileAbe'
import folders 							from './abe/folders'
import hasWorkFlow 					from './abe/hasWorkFlow'
import listPage 						from './abe/listPage'
import printBlock 					from './abe/printBlock'
import printConfig 					from './abe/printConfig'
import printInput 					from './abe/printInput'
import recursiveFolder 			from './abe/recursiveFolder'
import recursivePrintConfig from './abe/recursivePrintConfig'
import sourceAttr 					from './abe/sourceAttr'
import sourceAutocomplete 	from './abe/sourceAutocomplete'
import sourceOption 				from './abe/sourceOption'

/* Register utilities */
Handlebars.registerHelper('attrAbe', 		attrAbe)
Handlebars.registerHelper('className', 	className)
Handlebars.registerHelper('cleanTab', 	cleanTab)
Handlebars.registerHelper('ifCond', 		ifCond)
Handlebars.registerHelper('ifIn', 			ifIn)
Handlebars.registerHelper('math', 			math)
Handlebars.registerHelper('moduloIf', 	moduloIf)
Handlebars.registerHelper('notEmpty', 	notEmpty)
Handlebars.registerHelper('printJson', 	printJson)
Handlebars.registerHelper('testObj', 		testObj)
Handlebars.registerHelper('i18nAbe', 		translate)

/* Register abe */
Handlebars.registerHelper('abeImport', 	abeImport)
Handlebars.registerHelper('addWorkflow',addWorkflow)
Handlebars.registerHelper('abe', 				compileAbe)
Handlebars.registerHelper('folders', 		folders)
Handlebars.registerHelper('hasWorkFlow',hasWorkFlow)
Handlebars.registerHelper('listPage', 	listPage)
Handlebars.registerHelper('printBlock', printBlock)
Handlebars.registerHelper('printConfig',printConfig)
Handlebars.registerHelper('printInput', printInput)

HandlebarsIntl.registerWith(Handlebars)

export {
	attrAbe
	,className
	,cleanTab
	,ifCond
	,ifIn
	,math
	,moduloIf
	,notEmpty
	,printJson
	,testObj
	,translate
	,abeEngine
	,abeImport
	,addWorkflow
	,compileAbe
	,folders
	,hasWorkFlow
	,listPage
	,printBlock
	,printConfig
	,printInput
	,recursiveFolder
	,recursivePrintConfig
	,sourceAttr
	,sourceAutocomplete
	,sourceOption
}

